using System;
using System.Configuration;
using Plumbwork.Orange.Eventing;
using Microsoft.Web.Services2;
using Microsoft.Web.Services2.Addressing;
using Microsoft.Web.Services2.Messaging;

namespace Plumbwork.Orange.ClientCode
{
	class WSEventingClient
	{
		private static string strServiceEndpointURI = "soap.tcp://bit/eventingservice";
		private static string strClientReplyToURI = "soap.tcp://localhost:1000/eventingservice";
		private static string strClientNotifyToURI = "soap.tcp://localhost:2000/eventingservice";

		static void Main(string[] args)
		{
			SubscriptionServiceClient proxy = new SubscriptionServiceClient(new Uri(strServiceEndpointURI));

			Subscribe subscribeRequest = new Subscribe();
			subscribeRequest.EndTo = new Uri(strClientReplyToURI);
			subscribeRequest.Expires = DateTime.Now.AddHours(1);
			subscribeRequest.NotifyTo = new Uri(strClientNotifyToURI);

			SoapReceivers.Add(subscribeRequest.EndTo, typeof(EventingReceiver));
			SoapReceivers.Add(subscribeRequest.NotifyTo, typeof(EventingReceiver));

			SubscribeResponse subscribeResponse = proxy.Subscribe(subscribeRequest);
			
			Console.WriteLine("Subscription expires: " + subscribeResponse.Expires.ToString());
			Console.WriteLine("Message ID: " + subscribeResponse.Id.ToString());
			Console.WriteLine("Subscription response on: " + strClientReplyToURI);
			Console.WriteLine("Notify on: " + strClientNotifyToURI);
			Console.ReadLine();
		}
	}

	class EventingReceiver : SoapReceiver
	{
		protected override void Receive(SoapEnvelope envelope)
		{
			Console.WriteLine(envelope.OuterXml + "\n\n");
		}
	}
}
